Index: isc-dhcp/ANONCVS
===================================================================
RCS file: isc-dhcp/ANONCVS
diff -N isc-dhcp/ANONCVS
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ isc-dhcp/ANONCVS	9 Oct 2003 02:20:19 -0000
@@ -0,0 +1,129 @@
+	  Anonymous CVS Access for the ISC DHCP Distribution
+
+The ISC DHCP distribution can be accessed using "anonymous" CVS.
+"Anonymous" cvs uses the CVS "pserver" mechanism to allow anybody on
+the Internet to access a CVS repository without having to register in
+any way.   Anonymous CVS allows you to access changes as soon as the
+DHCP developers commit them, rather than having to wait for the next
+snapshot or patchlevel.   Changes that have not yet been released yet
+are not guaranteed to work, but they can nonetheless be useful in many
+cases.
+
+			  TABLE OF CONTENTS
+
+		1. What is anonymous CVS?
+		2. How can i start using it?
+		3. Checking out the latest code in a release
+		4. Checking out the latest code
+		5. Checking out a specific release
+		6. When to update
+
+			WHAT IS ANONYMOUS CVS?
+
+Anonymous CVS also allows you to browse through the history of the
+DHCP distribution, and examine the revision history of specific files
+to see how they have changed between revisions, to try to figure out
+why something that was working before is no longer working, or just to
+see when a certain change was made.
+
+		      HOW CAN I START USING IT?
+
+To use anonymous CVS to access the DHCP distribution, you must first
+"log in".   You should only need to do this once, but it is a
+necessary step, even though access is anonymous.   Anonymous users log
+in as user "nobody", password "nobody".   To do this, type:
+
+	cvs -d :pserver:nobody@dhcp.cvs.isc.org:/cvsroot login
+
+You will be prompted for a password - type "nobody".   If you get some
+kind of error indicating that cvs doesn't know how to log you in, you
+are probably running an old version of cvs, and should upgrade.   This
+should work with cvs version 1.10.
+
+Once you have logged in, you can check out a version of the DHCP
+distribution, so the next question is, which version?
+
+	      CHECKING OUT THE LATEST CODE IN A RELEASE
+
+There are currently four major versions of the distribution - Release
+1, Release 2, Release 3, and the current development tree.   Releases
+1, 2 and 3 are branches in the CVS repository.   To check out the
+latest code on any of these branches, you would use a branch tag of
+RELEASE_1, RELEASE_2 or RELEASE_3 in the following command:
+
+	(setenv CVSROOT :pserver:nobody@dhcp.cvs.isc.org:/cvsroot;
+	 cvs checkout -d dhcp-2.0 -r RELEASE_2 DHCP)
+
+Note that the example is for Release 2.
+
+		     CHECKING OUT THE LATEST CODE
+
+To check out the current engineering version, use:
+
+	(setenv CVSROOT :pserver:nobody@dhcp.cvs.isc.org:/cvsroot;
+	 cvs checkout -d dhcp-current DHCP)
+
+Note that the current engineering version is a work in progress, and
+there is no real guarantee that it will work for you.
+
+		   CHECKING OUT A SPECIFIC RELEASE
+
+You can also check out specific versions of the DHCP distribution.
+There are three kinds of version tags you may find - alpha tags, beta
+tags and release tags.   Alpha tags look like this:
+
+	V#-ALPHA-YYYYMMDD
+
+# is the release number.   YYYYMMDD is the date of the release, with a
+4-digit year, the month expressed as a number (January=1), and the day
+of the month specified as a number, with the first day of the month
+being 1.
+
+Beta tags look like this:
+
+	V#-BETA-%-PATCH-*
+
+Where # is the release number, % is the Beta number (usually 1) and *
+is the patchlevel.   In the future there may also be beta tags that
+look like this:
+
+	V#-#-BETA-%-PATCH-*
+
+Where #-# is the major version followed by the minor version - for
+example, when the first 3.1 beta comes out, the tag will look like
+this:
+
+	V3-1-BETA-1-PATCH-0
+
+Release tags look like this:
+
+	V#-%-*
+
+Where # is the major version, % is the minor version, and * is the
+patchlevel.   So the tag for 1.0pl2 is V1-0-2, and to check it out,
+you'd type:
+
+	(setenv CVSROOT :pserver:nobody@dhcp.cvs.isc.org:/cvsroot;
+	 cvs checkout -d dhcp-1.0pl2 -rV1-0-2 DHCP)
+
+Whenever changes are checked in to the ISC DHCP repository, or files
+are tagged, a notice is sent to the dhcp-source-changes@isc.org
+mailing list.   You can subscribe to this list by sending mail to
+dhcp-source-changes-request@isc.org, and you will then get immediate
+notification when changes are made.   You may find the volume of mail
+on this list annoying, however.
+
+			    WHEN TO UPDATE
+
+We do not recommend that you do an update immediately after you see a
+change on the dhcp-source-changes mailing list - instead, it's best to
+wait a while to make sure that any changes that change depends on have
+also been committed.   Also, sometimes when development is being done
+on two machines, the developers will check in a tentative change that
+hasn't been tested at all so that they can update on a different
+machine and test the change.   The best way to avoid accidentally
+getting one of these changes is to not update aggressively - when a
+change is made, wait a while before updating, to make sure that it's
+not going to be quickly followed by another change.
+
+
Index: isc-dhcp/FREEBSD-upgrade
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/FREEBSD-upgrade,v
retrieving revision 1.2
diff -u -r1.2 FREEBSD-upgrade
--- isc-dhcp/FREEBSD-upgrade	17 Jun 2003 04:24:02 -0000	1.2
+++ isc-dhcp/FREEBSD-upgrade	9 Oct 2003 02:20:19 -0000
@@ -1,8 +1,7 @@
 # ex:ts=8
-$FreeBSD: src/contrib/isc-dhcp/FREEBSD-upgrade,v 1.9.2.5 2003/03/02 16:42:37 murray Exp $
-$DragonFly: src/contrib/isc-dhcp/FREEBSD-upgrade,v 1.2 2003/06/17 04:24:02 dillon Exp $
+$FreeBSD: src/contrib/isc-dhcp/FREEBSD-upgrade,v 1.18 2003/09/02 11:15:03 mbr Exp $
 
-ISC DHCP client 3.0.1rc11
+ISC DHCP client 3.0.1rc12
 	originals can be found at: ftp://ftp.isc.org/isc/dhcp/
 
 
@@ -16,7 +15,7 @@
 	contrib/
 	dhcp.spec		solaris.init		ms2isc/
 
-	include/cf/
+	includes/cf/
 	aix.h			alphaosf.h		bsdos.h
 	cygwin32.h		hpux.h			irix.h
 	linux.h			netbsd.h		nextstep.h
@@ -29,7 +28,7 @@
 Imported by:
 
 	cvs import -m 'Import ISC DHCP 3.0.1 RC11 client.' \
-		src/contrib/isc-dhcp ISC isc_dhcp_3_0_1_rc11
+		src/contrib/isc-dhcp ISC isc_dhcp_3_0_1_rc12
 
 
 To make local changes to isc-dhcp, simply patch and commit to the main
@@ -43,21 +42,36 @@
 	client/clparse.c
 	  r1.6 - prefer strlcpy to strcpy.
 	client/dhclient.8 
-	  r1.8 - correct a man reference and a typo.
+	  r1.14 - interface polling
 	  r1.6 - document -D option.
           - remove dhcpd from SEE ALSO section.
 	client/dhclient.c
+	  r1.32 - interface polling
+	  r1.31 - interface polling
+	  r1.30 - interface polling
+	  r1.29 - interface polling
+	  r1.28 - interface polling
+	  r1.27 - interface polling
+	  r1.26 - interface polling
 	  r1.19 - connect std{in,out,err}.
 	  r1.13 - prefer strlcpy to strcpy.
 	  r1.6  - quiet by default.
 	        - document -D option.
 	client/dhclient.conf.5
-	  - Remove dhcpd from SEE ALSO section.
+	        - Remove dhcpd from SEE ALSO section.
 	common/dhcp-options.5
 	  r1.2 - note that hostname is only set if not already set.
-	  - Remove dhcpd from SEE ALSO section.
+	       - Remove dhcpd from SEE ALSO section.
+	common/dispatch.c
+	  r1.2 - interface polling
+	includes/dhcpd.h
+	  r1.5 - interface polling
+	  r1.4 - interface polling
+	  r1.3 - interface polling
+	  r1.2 - interface polling
     (see CVS logs for complete details)
 
+mbr@FreeBSD.org
 murray@FreeBSD.org
 obrien@NUXI.com
 15-Jan-2003
Index: isc-dhcp/README
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/README,v
retrieving revision 1.1
diff -u -r1.1 README
--- isc-dhcp/README	17 Jun 2003 02:44:59 -0000	1.1
+++ isc-dhcp/README	9 Oct 2003 02:20:19 -0000
@@ -1,6 +1,6 @@
 	    Internet Software Consortium DHCP Distribution
 			     Version 3.0.1
-			  Release Candidate 9
+			  Release Candidate 12
 			     April 28, 2002
 
 			      README FILE
@@ -97,7 +97,7 @@
 
 			    RELEASE STATUS
 
-This is the tenth release candidate of version 3.0.1 of the ISC DHCP
+This is the twelfth release candidate of version 3.0.1 of the ISC DHCP
 Distribution.  Development of this release is approaching the point at
 which it will be frozen, and no significant new features will be
 added.
Index: isc-dhcp/RELNOTES
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/RELNOTES,v
retrieving revision 1.1
diff -u -r1.1 RELNOTES
--- isc-dhcp/RELNOTES	17 Jun 2003 02:44:59 -0000	1.1
+++ isc-dhcp/RELNOTES	9 Oct 2003 02:20:19 -0000
@@ -1,6 +1,6 @@
 	    Internet Software Consortium DHCP Distribution
 			     Version 3.0.1
-			 Release Candidate 10
+			 Release Candidate 12
 			       June, 2002
 
 			     Release Notes
@@ -45,6 +45,53 @@
 Murrell at BC Tel Advanced Communications.  I'd like to express my
 thanks to all of these good people here, both for working on the code
 and for prodding me into improving it.
+
+			Changes since 3.0.1rc11
+
+- A patch from Steve Campbell was applied with minor modifications to
+  permit reverse dns PTR record updates with values containing spaces.
+
+- A patch from Florian Lohoff was applied with some modifications to
+  dhcrelay.  It now discards packets whose hop count exceeds 10 by default,
+  and a command-line option (-c) can be used to set this threshold.
+
+- A failover bug relating to identifying peers by name length instead of
+  by name was fixed.
+
+- Delcaring failover configs within shared-network statements should no
+  longer result in error.
+
+- The -nw command line option to dhclient now works.
+
+- Thanks to a patch from Michael Richardson:
+	- Some problems with long option processing have been fixed.
+	- Some fixes to minires so that updates of KEY records will work.
+
+- contrib/ms2isc was updated by Shu-Min Chang of the Intel Corporation.
+  see contrib/ms2isc/readme.txt for revision notes.
+
+- Dhclient no longer uses shell commands to kill another instance of
+  itself, it sends the signal directly.  Thanks to a patch from Martin
+  Blapp.
+
+- The FreeBSD dhclient-script was changed so that a failure to write to
+  /etc/resolv.conf does not prematurely end the script.  This keeps dhclient
+  from looping infinitely when this is the case.  Thanks to a patch from
+  Martin Blapp.
+
+- A patch from Bill Stephens was applied which resolves a problem with lease
+  expiry times in failover configurations.
+
+- A memory leak in configuration parsing was closed thanks to a patch from
+  Steve G.
+
+- The function which discovers interfaces will now skip non-broadcast or
+  point-to-point interfaces, thanks to a patch from David Brownlee.
+
+- Options not yet known by the dhcpd or dhclient have had their names
+  changed such that they do not contain # symbols, in case they should ever
+  appear in a lease file.  An option that might have been named "#144" is
+  now "unknown-144".
 
 			Changes since 3.0.1rc10
 
Index: isc-dhcp/client/clparse.c
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/client/clparse.c,v
retrieving revision 1.2
diff -u -r1.2 clparse.c
--- isc-dhcp/client/clparse.c	17 Jun 2003 04:24:02 -0000	1.2
+++ isc-dhcp/client/clparse.c	9 Oct 2003 02:21:32 -0000
@@ -40,22 +40,18 @@
  * see ``http://www.vix.com''.   To learn more about Nominum, Inc., see
  * ``http://www.nominum.com''.
  *
- * @(#) Copyright (c) 1996-2002 The Internet Software Consortium.  All rights reserved.
- * $Id: clparse.c,v 1.62.2.3 2002/11/17 02:25:43 dhankins Exp $
- * $FreeBSD: src/contrib/isc-dhcp/client/clparse.c,v 1.4.2.4 2003/03/02 16:42:37 murray Exp $
- * $DragonFly: src/contrib/isc-dhcp/client/clparse.c,v 1.2 2003/06/17 04:24:02 dillon Exp $
+ * $Id: clparse.c,v 1.62.2.4 2003/02/10 00:39:57 dhankins Exp $ Copyright (c) 1996-2002 The Internet Software Consortium.  All rights reserved.
+ * $FreeBSD: src/contrib/isc-dhcp/client/clparse.c,v 1.11 2003/09/02 11:13:20 mbr Exp $
+ * $DragonFly$
  */
 
-static char copyright[] =
-"$Id: clparse.c,v 1.62.2.3 2002/11/17 02:25:43 dhankins Exp $ Copyright (c) 1996-2002 The Internet Software Consortium.  All rights reserved.\n";
-
 #include "dhcpd.h"
 
 static TIME parsed_time;
 
 struct client_config top_level_config;
 
-char client_script_name [] = "/sbin/dhclient-script";
+char client_script_name [] = _PATH_DHCLIENT_SCRIPT;
 
 u_int32_t default_requested_options [] = {
 	DHO_SUBNET_MASK,
@@ -622,34 +618,41 @@
 	struct parse *cfile;
 	u_int32_t **list;
 {
-	int ix, i;
+	int ix;
 	int token;
 	const char *val;
 	pair p = (pair)0, q, r;
+	struct option *option;
 
 	ix = 0;
 	do {
-		token = next_token (&val, (unsigned *)0, cfile);
-		if (token == SEMI)
+		token = peek_token (&val, (unsigned *)0, cfile);
+		if (token == SEMI) {
+			token = next_token (&val, (unsigned *)0, cfile);
 			break;
+		}
 		if (!is_identifier (token)) {
 			parse_warn (cfile, "%s: expected option name.", val);
+			token = next_token (&val, (unsigned *)0, cfile);
 			skip_to_semi (cfile);
 			return;
 		}
-		for (i = 0; i < 256; i++) {
-			if (!strcasecmp (dhcp_options [i].name, val))
-				break;
-		}
-		if (i == 256) {
+		option = parse_option_name (cfile, 0, NULL);
+		if (!option) {
 			parse_warn (cfile, "%s: expected option name.", val);
+			return;
+		}
+		if (option -> universe != &dhcp_universe) {
+			parse_warn (cfile,
+				"%s.%s: Only global options allowed.",
+				option -> universe -> name, option->name );
 			skip_to_semi (cfile);
 			return;
 		}
 		r = new_pair (MDL);
 		if (!r)
 			log_fatal ("can't allocate pair for option code.");
-		r -> car = (caddr_t)(long)i;
+		r -> car = (caddr_t)(long)option -> code;
 		r -> cdr = (pair)0;
 		if (p)
 			q -> cdr = r;
Index: isc-dhcp/client/dhclient.c
===================================================================
RCS file: /cvs/src/contrib/isc-dhcp/client/dhclient.c,v
retrieving revision 1.2
diff -u -r1.2 dhclient.c
--- isc-dhcp/client/dhclient.c	17 Jun 2003 04:24:02 -0000	1.2
+++ isc-dhcp/client/dhclient.c	9 Oct 2003 02:34:10 -0000
@@ -38,17 +38,23 @@
  * by Ted Lemon since then, so any mistakes you find are probably his
  * fault and not Elliot's.
  *
- * @(#) Copyright (c) 1995-2002 Internet Software Consortium.  All rights reserved.";
- * $Id: dhclient.c,v 1.129.2.12 2002/11/07 23:26:38 dhankins Exp $
- * $FreeBSD: src/contrib/isc-dhcp/client/dhclient.c,v 1.9.2.8 2003/03/23 23:33:05 mbr Exp $
- * $DragonFly: src/contrib/isc-dhcp/client/dhclient.c,v 1.2 2003/06/17 04:24:02 dillon Exp $
+ * $Id: dhclient.c,v 1.129.2.16 2003/04/26 21:51:39 dhankins Exp $ Copyright (c) 1995-2002 Internet Software Consortium.  All rights reserved.
+ * $FreeBSD: src/contrib/isc-dhcp/client/dhclient.c,v 1.34 2003/09/02 11:09:45 mbr Exp $
+ * $DragonFly$
  */
 
-static char ocopyright[] = "$Id: dhclient.c,v 1.129.2.12 2002/11/07 23:26:38 dhankins Exp $ Copyright (c) 1995-2002 Internet Software Consortium.  All rights reserved.";
-
 #include "dhcpd.h"
 #include "version.h"
 
+#ifdef __FreeBSD__
+#include <sys/ioctl.h>
+#include <net/if_media.h>
+#if defined(DRAGONFLY_FUTURE)
+#include <net80211/ieee80211_ioctl.h>
+#include <net80211/ieee80211.h>
+#endif
+#endif
+
 TIME cur_time;
 TIME default_lease_time = 43200; /* 12 hours... */
 TIME max_lease_time = 86400; /* 24 hours... */
@@ -86,6 +92,10 @@
 int onetry=0;
 int quiet=1;
 int nowait=0;
+int doinitcheck=0;
+#ifdef ENABLE_POLLING_MODE
+int polling_interval = 5;
+#endif
 
 static void usage PROTO ((void));
 
@@ -95,7 +105,7 @@
 	int argc;
 	char **argv, **envp;
 {
-	int i, e;
+	int i;
 	struct servent *ent;
 	struct interface_info *ip;
 	struct client_state *client;
@@ -112,11 +122,8 @@
 	int no_dhclient_db = 0;
 	int no_dhclient_pid = 0;
 	int no_dhclient_script = 0;
-	FILE *pidfd;
-	pid_t oldpid;
 	char *s;
 
-	oldpid = 0;
 	/* Make sure we have stdin, stdout and stderr. */
 	i = open ("/dev/null", O_RDWR);
 	if (i == 0)
@@ -189,6 +196,9 @@
 		} else if (!strcmp (argv [i], "-q")) {
 			quiet = 1;
 			quiet_interface_discovery = 1;
+		} else if (!strcmp (argv [i], "-v")) {
+			quiet = 0;
+			quiet_interface_discovery = 0;
 		} else if (!strcmp (argv [i], "-s")) {
 			if (++i == argc)
 				usage ();
@@ -197,9 +207,24 @@
 			if (++i == argc)
 				usage ();
 			relay = argv [i];
+		} else if (!strcmp (argv [i], "-nw")) {
+			nowait = 1;
 		} else if (!strcmp (argv [i], "-n")) {
 			/* do not start up any interfaces */
 			interfaces_requested = 1;
+#ifdef ENABLE_POLLING_MODE
+		} else if (!strcmp (argv [i], "-i")) {
+			if (++i == argc)
+				usage ();
+			polling_interval = (int)strtol (argv [i],
+			    (char **)NULL, 10);
+			if (polling_interval <= 0) {
+				log_info ("Incorrect polling interval %d",
+				    polling_interval);
+				log_info ("Using a default of 5 seconds");
+				polling_interval = 5;
+			}
+#endif
 		} else if (!strcmp (argv [i], "-w")) {
 			/* do not exit if there are no broadcast interfaces. */
 			persist = 1;
@@ -217,8 +242,6 @@
 		} else if (!strcmp (argv [i], "--version")) {
 			log_info ("isc-dhclient-%s", DHCP_VERSION);
 			exit (0);
-		} else if (!strcmp (argv [i], "-nw")) {
-			nowait = 1;
  		} else if (argv [i][0] == '-') {
  		    usage ();
 		} else {
@@ -231,6 +254,18 @@
 			    log_fatal ("%s: interface name too long (max %ld)",
 				       argv [i], (long)strlen (argv [i]));
  		    strlcpy (tmp -> name, argv [i], IFNAMSIZ);
+#ifdef __FreeBSD__
+#if defined(DRAGONFLY_FUTURE)
+		    set_ieee80211 (tmp);
+#endif
+#endif
+		    /* Init some interface vars, enable polling */
+#ifdef ENABLE_POLLING_MODE
+		    tmp -> forcediscover = 0;
+		    tmp -> linkstate = HAVELINK;
+		    tmp -> polling = 1;
+#endif /* ifdef ENABLE_POLLING_MODE */
+
 		    if (interfaces) {
 			    interface_reference (&tmp -> next,
 						 interfaces, MDL);
@@ -258,12 +293,19 @@
 	/* first kill of any currently running client */
 	if (release_mode) {
 
+		FILE *pidfd;
+		pid_t oldpid;
+		long temp;
+		int e;
+
+		oldpid = 0;
 		if ((pidfd = fopen(path_dhclient_pid, "r")) != NULL) {
-			e = fscanf(pidfd, "%d", &oldpid);
+			e = fscanf(pidfd, "%ld\n", &temp);
+			oldpid = (pid_t)temp;
 
 			if (e != 0 && e != EOF) {
 				if (oldpid) {
-					if (kill(oldpid, SIGKILL) == 0)
+					if (kill(oldpid, SIGTERM) == 0)
 						unlink(path_dhclient_pid);
 				}
 			}
@@ -384,6 +426,18 @@
 					     INTERFACE_AUTOMATIC)) !=
 			     INTERFACE_REQUESTED))
 				continue;
+#ifdef __FreeBSD__
+#if defined(DRAGONFLY_FUTURE)
+			set_ieee80211 (ip);
+#endif
+#endif
+#ifdef ENABLE_POLLING_MODE
+			ip -> forcediscover = 0;
+			if (ip -> client -> config -> media != NULL)
+				ip -> havemedia = 1;
+			else
+				ip -> havemedia = 0;
+#endif
 			script_init (ip -> client,
 				     "PREINIT", (struct string_list *)0);
 			if (ip -> client -> alias)
@@ -426,8 +480,13 @@
 				client -> state = S_INIT;
 				/* Set up a timeout to start the initialization
 				   process. */
+#ifdef ENABLE_POLLING_MODE
+				add_timeout (cur_time + random () % 5 + 2,
+					     state_polling, client, 0, 0);
+#else
 				add_timeout (cur_time + random () % 5,
 					     state_reboot, client, 0, 0);
+#endif
 			}
 		}
 	}
@@ -875,6 +934,15 @@
 	/* Write out the new lease. */
 	write_client_lease (client, client -> new, 0, 0);
 
+	/*
+	 * It's now possible that state_reboot can be called
+	 * after a interface link went down and is up again.
+	 * To prevent tons of equal leases saved on disk, we rewrite
+	 * them.
+	 */
+	read_client_leases ();
+	rewrite_client_leases ();
+
 	/* Replace the old active lease with the new one. */
 	if (client -> active)
 		destroy_client_lease (client -> active);
@@ -889,6 +957,12 @@
 	      piaddr (client -> active -> address),
 	      (long)(client -> active -> renewal - cur_time));
 	client -> state = S_BOUND;
+#ifdef ENABLE_POLLING_MODE
+	/* Init some interface vars, enable polling */
+	client -> interface -> linkstate = HAVELINK;
+	client -> interface -> forcediscover = 0;
+	client -> interface -> polling = 1;
+#endif /* ifdef ENABLE_POLLING_MODE */
 	reinitialize_interfaces ();
 	go_daemon ();
 	if (client -> config -> do_forward_update) {
@@ -1351,6 +1425,11 @@
 	int interval;
 	int increase = 1;
 
+#ifdef ENABLE_POLLING_MODE
+	/* Disable polling for this interface */
+	client -> interface -> polling = 0;
+#endif
+
 	/* Figure out how long it's been since we started transmitting. */
 	interval = cur_time - client -> first_sending;
 
@@ -1456,6 +1535,9 @@
 	struct client_lease *loop;
 	struct client_lease *lp;
 
+	if (client -> interface -> linkstate == NOLINK)
+		return;
+
 	loop = lp = client -> active;
 
 	log_info ("No DHCPOFFERS received.");
@@ -1488,6 +1570,10 @@
 				log_info ("bound: renewal in %ld %s.",
 					  (long)(client -> active -> renewal -
 						 cur_time), "seconds");
+#ifdef ENABLE_POLLING_MODE
+				/* Enable polling for this interface */
+				client -> interface -> polling = 1;
+#endif
 				add_timeout (client -> active -> renewal,
 					     state_bound, client, 0, 0);
 			    } else {
@@ -1495,6 +1581,11 @@
 				log_info ("bound: immediate renewal.");
 				state_bound (client);
 			    }
+			    /*
+			     * Set the link status back to nolink, even
+			     * if we have media settings.
+			     */
+			    client -> interface -> linkstate = NOLINK;
 			    reinitialize_interfaces ();
 			    go_daemon ();
 			    return;
@@ -1540,6 +1631,12 @@
 	}
 
 	log_info ("No working leases in persistent database - sleeping.");
+
+#ifdef ENABLE_POLLING_MODE
+	/* Enable polling for this interface */
+	client -> interface -> polling = 1;
+#endif
+
 	script_init (client, "FAIL", (struct string_list *)0);
 	if (client -> alias)
 		script_write_params (client, "alias_", client -> alias);
@@ -1877,10 +1974,17 @@
 	/* Set up the option buffer... */
 	client -> packet_length =
 		cons_options ((struct packet *)0, &client -> packet,
-			      (struct lease *)0, client, 0,
-			      (struct option_state *)0, options,
-			      &global_scope, 0, 0, 0, (struct data_string *)0,
+			      (struct lease *)0, client,
+			      /* maximum packet size */1500,
+			      (struct option_state *)0,
+			      options,
+			      /* scope */ &global_scope,
+			      /* overload */ 0,
+			      /* terminate */0,
+			      /* bootpp    */0,
+			      (struct data_string *)0,
 			      client -> config -> vendor_space_name);
+
 	option_state_dereference (&options, MDL);
 	if (client -> packet_length < BOOTP_MIN_LEN)
 		client -> packet_length = BOOTP_MIN_LEN;
@@ -1944,10 +2048,17 @@
 	/* Set up the option buffer... */
 	client -> packet_length =
 		cons_options ((struct packet *)0, &client -> packet,
-			      (struct lease *)0, client, 0,
-			      (struct option_state *)0, client -> sent_options,
-			      &global_scope, 0, 0, 0, (struct data_string *)0,
+			      (struct lease *)0, client,
+			      /* maximum packet size */1500,
+			      (struct option_state *)0,
+			      client -> sent_options, 
+			      /* scope */ &global_scope,
+			      /* overload */ 0,
+			      /* terminate */0,
+			      /* bootpp    */0,
+			      (struct data_string *)0,
 			      client -> config -> vendor_space_name);
+
 	option_state_dereference (&client -> sent_options, MDL);
 	if (client -> packet_length < BOOTP_MIN_LEN)
 		client -> packet_length = BOOTP_MIN_LEN;
@@ -2073,10 +2184,17 @@
 	/* Set up the option buffer... */
 	client -> packet_length =
 		cons_options ((struct packet *)0, &client -> packet,
-			      (struct lease *)0, client, 0,
-			      (struct option_state *)0, options,
-			      &global_scope, 0, 0, 0, (struct data_string *)0,
+			      (struct lease *)0, client,
+			      /* maximum packet size */1500,
+			      (struct option_state *)0,
+			      options,
+			      /* scope */ &global_scope,
+			      /* overload */ 0,
+			      /* terminate */0,
+			      /* bootpp    */0,
+			      (struct data_string *)0,
 			      client -> config -> vendor_space_name);
+
 	if (client -> packet_length < BOOTP_MIN_LEN)
 		client -> packet_length = BOOTP_MIN_LEN;
 	option_state_dereference (&options, MDL);
@@ -2768,8 +2886,10 @@
 			      case S_STOPPED:
 				break;
 			}
+#ifndef ENABLE_POLLING_MODE
 			client -> state = S_INIT;
 			state_reboot (client);
+#endif
 		}
 	}
 }
@@ -2995,7 +3115,9 @@
 		    break;
 
 		  case server_awaken:
+#ifndef ENABLE_POLLING_MODE
 		    state_reboot (client);
+#endif
 		    break;
 		}
 	    }
@@ -3132,3 +3254,261 @@
 	data_string_forget (&ddns_dhcid, MDL);
 	return rcode;
 }
+
+/* Check to see if there's a wire plugged in */
+int
+interface_active(struct interface_info *ip) {
+#ifdef __FreeBSD__
+	struct ifmediareq ifmr;
+	int *media_list, i;
+	char *ifname;
+	int sock;
+
+	ifname = ip -> name;
+
+	if ((sock = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
+		log_fatal ("Can't create interface_active socket");
+
+	(void) memset (&ifmr, 0, sizeof (ifmr));
+	(void) strncpy (ifmr.ifm_name, ifname, sizeof (ifmr.ifm_name));
+
+	if (ioctl (sock, SIOCGIFMEDIA, (caddr_t)&ifmr) < 0) {
+		/*
+		 * Interface doesn't support SIOCGIFMEDIA, presume okay
+		 */
+		close (sock);
+		return (HAVELINK);
+	}
+	close (sock);
+
+	if (ifmr.ifm_count == 0) {
+		/*
+		 * Assume that this means interface
+		 * does not support SIOCGIFMEDIA
+		 */
+		log_fatal ("%s: no media types?", ifname);
+		return (HAVELINK);
+	}
+
+	if (ifmr.ifm_status & IFM_AVALID) {
+		if (ip -> ieee80211) {
+			/*
+			 * Wavelan devices need to be checked if they are
+			 * associated.
+			 */
+			if ((IFM_TYPE(ifmr.ifm_active) == IFM_IEEE80211) &&
+			     (ifmr.ifm_status & IFM_ACTIVE)) {
+				return (HAVELINK);
+			}
+		} else {
+			if (ifmr.ifm_status & IFM_ACTIVE) {
+				return (HAVELINK);
+			}
+		}
+		/*
+		 * We really have no link.
+		 */
+		return (NOLINK);
+	}
+	/*
+	 * IFM_AVALID is not set. We cannot check
+	 * the link state. Assume HAVELINK.
+	 */
+
+#endif /* Other OSs */
+	/*
+	 * Always return a successful link if the OS
+	 * is not supported.
+	 */
+	return (HAVELINK);
+}
+
+#ifdef __FreeBSD__
+#if defined(DRAGONFLY_FUTURE)
+void
+set_ieee80211 (struct interface_info *ip) {
+
+	struct ieee80211req     ireq;
+	u_int8_t                data[32];
+	int                     associated = 0;
+	int *media_list, i;
+	char *ifname;
+	int sock;
+
+	ifname = ip -> name;
+
+	if ((sock = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
+		log_fatal ("Can't create interface_active socket");
+
+	(void) memset (&ireq, 0, sizeof (ireq));
+	(void) strncpy (ireq.i_name, ifname, sizeof (ireq.i_name));
+	ireq.i_data = &data;
+	ireq.i_type = IEEE80211_IOC_SSID;
+	ireq.i_val = -1;
+	/*
+	 * If we can't get the SSID,
+	 * this isn't an 802.11 device.
+	 */
+	if (ioctl (sock, SIOCG80211, &ireq) < 0)
+		ip -> ieee80211 = 0;
+	else {
+#ifdef DEBUG
+		printf ("Device %s has 802.11\n", ifname);
+#endif
+		ip -> ieee80211 = 1;
+	}
+	close (sock);
+}
+#endif /* __FreeBSD__ */
+#endif
+
+#ifdef ENABLE_POLLING_MODE
+/* Go to background after some time */
+void state_background (cpp)
+	void *cpp;
+{
+	go_daemon ();
+}
+
+/* Check the state of the NICs if we have link */
+void state_polling (cpp)
+        void *cpp;
+{
+	struct interface_info *ip;
+	struct client_state *client;
+	int result;
+
+	for (ip = interfaces; ip; ip = ip -> next) {
+		if (! ip -> polling)
+			continue;
+#ifdef DEBUG
+		printf ("%s: Polling interface state\n", ip -> name);
+		for (client = ip -> client;
+		     client; client = client -> next) {
+			printf ("%s: client state of %d\n", ip -> name, ip -> client -> state);
+			printf ("%s: link = %d\n", ip -> name, ip -> linkstate);
+		}
+#endif
+
+		result = interface_active (ip);
+		/*
+		 * If dhclient.conf contains media settings, we cannot
+		 * abort if the interface is not set to active mode.
+		 */
+		if (ip -> havemedia && ip -> client -> state != S_BOUND) {
+			if (result == HAVELINK)
+				ip -> forcediscover = 1;
+			result = HAVELINK;
+		}
+
+		/*
+		 * The last status of the interface tells us
+		 * the we've got no link ...
+		 */
+		if (ip -> linkstate == NOLINK || ! doinitcheck) {
+			/*
+			 * ... but we have now link. Let's send
+			 * requests.
+			 */
+			if (result == HAVELINK) {
+#ifdef DEBUG
+				if (ip -> havemedia)
+					printf ("%s: Trying media settings on interface\n",
+						ip -> name);
+				else
+					printf ("%s: Found Link on interface\n", ip -> name);
+#endif
+				/*
+				 * Set the interface to state_reboot. But of
+				 * course we can not be sure that we really got link,
+				 * we just assume it.
+				 */
+				for (client = ip -> client;
+				     client; client = client -> next) {
+						cancel_timeout (state_init, client);
+						cancel_timeout (state_reboot, client);
+						cancel_timeout (state_selecting, client);
+						add_timeout (cur_time + random () % 5,
+							    state_reboot, client, 0, 0);
+				}
+				ip -> linkstate = HAVELINK;
+			} else {
+#ifdef DEBUG
+				printf ("%s: No link on interface\n", ip -> name);
+#endif
+				for (client = ip -> client;
+				     client; client = client -> next) {
+					/*
+					 * Without this add_timout(), dhclient does
+					 * not poll on a interface if there
+					 * is no cable plugged in at startup
+					 * time. Because we add one additional second 
+					 * to the time of a normal timeout, we always
+					 * skip and block a running one. This prevents
+					 * that polling is done twice at the same time.
+					 */
+					if (client -> state == S_INIT) {
+						add_timeout (cur_time + (polling_interval + 1),
+						             state_polling, client, 0, 0);
+					}
+			 	}
+				ip -> linkstate = NOLINK;
+				/*
+				 * Automatically go into the background after
+				 * some time. Do this only if there are no
+				 * media options available for a interface.
+				 */
+				if (! ip -> havemedia && ! doinitcheck) {
+					add_timeout (cur_time + (polling_interval * 2),
+					            state_background, client, 0, 0);
+				}
+			}
+		}
+
+		/*
+		 * The last status of the interface tells us
+		 * the we previously had link.
+		 */
+		if (ip -> linkstate == HAVELINK && doinitcheck) {
+			if (result == NOLINK) {
+				/*
+				 * We lost link on the interface, or it isn't
+				 * associated anymore.
+				 */
+#ifdef DEBUG
+				printf ("%s: Lost Link on interface\n", ip -> name);
+#endif
+				/*
+				 * After we lost link, cycle again through the
+				 * different media settings if available. Else
+				 * set NOLINK.
+				 */
+				if (ip -> havemedia)
+					ip -> forcediscover = 1;
+				else
+					ip -> linkstate = NOLINK;
+			}
+			/*
+			 * If we happen to have a real link, but no
+			 * active lease, force the interface into
+			 * state_reboot. Do the same if media settings
+			 * are available.
+			 */
+			if (ip -> forcediscover) {
+				for (client = ip -> client;
+				     client; client = client -> next) {
+					if (client -> state != S_REBOOTING &&
+					    client -> state != S_SELECTING) {
+						add_timeout (cur_time + random () % 5,
+							    state_reboot, client, 0, 0);
+					}
+				}
+				ip -> forcediscover = 0;
+				ip -> linkstate = HAVELINK;
+			}
+			/* We still have link, do nothing. */
+		}
+	}
+	doinitcheck = 1;
+}
+#endif /* ifdef ENABLE_POLLING_MODE */
